// Generated by the protocol buffer compiler.  DO NOT EDIT!
// source: StateDefinition.proto

package ru.omnicomm.pegasus.messaging.settings.statedefinition;

public final class StateDefinitionSettingsParser {
  private StateDefinitionSettingsParser() {}
  public static void registerAllExtensions(
      com.google.protobuf.ExtensionRegistry registry) {
  }
  public interface StateDefinitionMessageSettingsOrBuilder
      extends com.google.protobuf.MessageOrBuilder {
    
    // optional int64 sourceId = 1;
    boolean hasSourceId();
    long getSourceId();
    
    // required int64 messageType = 2 [default = 526];
    boolean hasMessageType();
    long getMessageType();
    
    // optional int64 timeStamp = 5;
    boolean hasTimeStamp();
    long getTimeStamp();
    
    // optional int64 timeInterval = 101;
    boolean hasTimeInterval();
    long getTimeInterval();
    
    // optional int64 time = 102;
    boolean hasTime();
    long getTime();
  }
  public static final class StateDefinitionMessageSettings extends
      com.google.protobuf.GeneratedMessage
      implements StateDefinitionMessageSettingsOrBuilder {
    // Use StateDefinitionMessageSettings.newBuilder() to construct.
    private StateDefinitionMessageSettings(Builder builder) {
      super(builder);
    }
    private StateDefinitionMessageSettings(boolean noInit) {}
    
    private static final StateDefinitionMessageSettings defaultInstance;
    public static StateDefinitionMessageSettings getDefaultInstance() {
      return defaultInstance;
    }
    
    public StateDefinitionMessageSettings getDefaultInstanceForType() {
      return defaultInstance;
    }
    
    public static final com.google.protobuf.Descriptors.Descriptor
        getDescriptor() {
      return ru.omnicomm.pegasus.messaging.settings.statedefinition.StateDefinitionSettingsParser.internal_static_ru_omnicomm_pegasus_messaging_settings_statedefinition_StateDefinitionMessageSettings_descriptor;
    }
    
    protected com.google.protobuf.GeneratedMessage.FieldAccessorTable
        internalGetFieldAccessorTable() {
      return ru.omnicomm.pegasus.messaging.settings.statedefinition.StateDefinitionSettingsParser.internal_static_ru_omnicomm_pegasus_messaging_settings_statedefinition_StateDefinitionMessageSettings_fieldAccessorTable;
    }
    
    private int bitField0_;
    // optional int64 sourceId = 1;
    public static final int SOURCEID_FIELD_NUMBER = 1;
    private long sourceId_;
    public boolean hasSourceId() {
      return ((bitField0_ & 0x00000001) == 0x00000001);
    }
    public long getSourceId() {
      return sourceId_;
    }
    
    // required int64 messageType = 2 [default = 526];
    public static final int MESSAGETYPE_FIELD_NUMBER = 2;
    private long messageType_;
    public boolean hasMessageType() {
      return ((bitField0_ & 0x00000002) == 0x00000002);
    }
    public long getMessageType() {
      return messageType_;
    }
    
    // optional int64 timeStamp = 5;
    public static final int TIMESTAMP_FIELD_NUMBER = 5;
    private long timeStamp_;
    public boolean hasTimeStamp() {
      return ((bitField0_ & 0x00000004) == 0x00000004);
    }
    public long getTimeStamp() {
      return timeStamp_;
    }
    
    // optional int64 timeInterval = 101;
    public static final int TIMEINTERVAL_FIELD_NUMBER = 101;
    private long timeInterval_;
    public boolean hasTimeInterval() {
      return ((bitField0_ & 0x00000008) == 0x00000008);
    }
    public long getTimeInterval() {
      return timeInterval_;
    }
    
    // optional int64 time = 102;
    public static final int TIME_FIELD_NUMBER = 102;
    private long time_;
    public boolean hasTime() {
      return ((bitField0_ & 0x00000010) == 0x00000010);
    }
    public long getTime() {
      return time_;
    }
    
    private void initFields() {
      sourceId_ = 0L;
      messageType_ = 526L;
      timeStamp_ = 0L;
      timeInterval_ = 0L;
      time_ = 0L;
    }
    private byte memoizedIsInitialized = -1;
    public final boolean isInitialized() {
      byte isInitialized = memoizedIsInitialized;
      if (isInitialized != -1) return isInitialized == 1;
      
      if (!hasMessageType()) {
        memoizedIsInitialized = 0;
        return false;
      }
      memoizedIsInitialized = 1;
      return true;
    }
    
    public void writeTo(com.google.protobuf.CodedOutputStream output)
                        throws java.io.IOException {
      getSerializedSize();
      if (((bitField0_ & 0x00000001) == 0x00000001)) {
        output.writeInt64(1, sourceId_);
      }
      if (((bitField0_ & 0x00000002) == 0x00000002)) {
        output.writeInt64(2, messageType_);
      }
      if (((bitField0_ & 0x00000004) == 0x00000004)) {
        output.writeInt64(5, timeStamp_);
      }
      if (((bitField0_ & 0x00000008) == 0x00000008)) {
        output.writeInt64(101, timeInterval_);
      }
      if (((bitField0_ & 0x00000010) == 0x00000010)) {
        output.writeInt64(102, time_);
      }
      getUnknownFields().writeTo(output);
    }
    
    private int memoizedSerializedSize = -1;
    public int getSerializedSize() {
      int size = memoizedSerializedSize;
      if (size != -1) return size;
    
      size = 0;
      if (((bitField0_ & 0x00000001) == 0x00000001)) {
        size += com.google.protobuf.CodedOutputStream
          .computeInt64Size(1, sourceId_);
      }
      if (((bitField0_ & 0x00000002) == 0x00000002)) {
        size += com.google.protobuf.CodedOutputStream
          .computeInt64Size(2, messageType_);
      }
      if (((bitField0_ & 0x00000004) == 0x00000004)) {
        size += com.google.protobuf.CodedOutputStream
          .computeInt64Size(5, timeStamp_);
      }
      if (((bitField0_ & 0x00000008) == 0x00000008)) {
        size += com.google.protobuf.CodedOutputStream
          .computeInt64Size(101, timeInterval_);
      }
      if (((bitField0_ & 0x00000010) == 0x00000010)) {
        size += com.google.protobuf.CodedOutputStream
          .computeInt64Size(102, time_);
      }
      size += getUnknownFields().getSerializedSize();
      memoizedSerializedSize = size;
      return size;
    }
    
    private static final long serialVersionUID = 0L;
    @java.lang.Override
    protected java.lang.Object writeReplace()
        throws java.io.ObjectStreamException {
      return super.writeReplace();
    }
    
    public static ru.omnicomm.pegasus.messaging.settings.statedefinition.StateDefinitionSettingsParser.StateDefinitionMessageSettings parseFrom(
        com.google.protobuf.ByteString data)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return newBuilder().mergeFrom(data).buildParsed();
    }
    public static ru.omnicomm.pegasus.messaging.settings.statedefinition.StateDefinitionSettingsParser.StateDefinitionMessageSettings parseFrom(
        com.google.protobuf.ByteString data,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return newBuilder().mergeFrom(data, extensionRegistry)
               .buildParsed();
    }
    public static ru.omnicomm.pegasus.messaging.settings.statedefinition.StateDefinitionSettingsParser.StateDefinitionMessageSettings parseFrom(byte[] data)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return newBuilder().mergeFrom(data).buildParsed();
    }
    public static ru.omnicomm.pegasus.messaging.settings.statedefinition.StateDefinitionSettingsParser.StateDefinitionMessageSettings parseFrom(
        byte[] data,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return newBuilder().mergeFrom(data, extensionRegistry)
               .buildParsed();
    }
    public static ru.omnicomm.pegasus.messaging.settings.statedefinition.StateDefinitionSettingsParser.StateDefinitionMessageSettings parseFrom(java.io.InputStream input)
        throws java.io.IOException {
      return newBuilder().mergeFrom(input).buildParsed();
    }
    public static ru.omnicomm.pegasus.messaging.settings.statedefinition.StateDefinitionSettingsParser.StateDefinitionMessageSettings parseFrom(
        java.io.InputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return newBuilder().mergeFrom(input, extensionRegistry)
               .buildParsed();
    }
    public static ru.omnicomm.pegasus.messaging.settings.statedefinition.StateDefinitionSettingsParser.StateDefinitionMessageSettings parseDelimitedFrom(java.io.InputStream input)
        throws java.io.IOException {
      Builder builder = newBuilder();
      if (builder.mergeDelimitedFrom(input)) {
        return builder.buildParsed();
      } else {
        return null;
      }
    }
    public static ru.omnicomm.pegasus.messaging.settings.statedefinition.StateDefinitionSettingsParser.StateDefinitionMessageSettings parseDelimitedFrom(
        java.io.InputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      Builder builder = newBuilder();
      if (builder.mergeDelimitedFrom(input, extensionRegistry)) {
        return builder.buildParsed();
      } else {
        return null;
      }
    }
    public static ru.omnicomm.pegasus.messaging.settings.statedefinition.StateDefinitionSettingsParser.StateDefinitionMessageSettings parseFrom(
        com.google.protobuf.CodedInputStream input)
        throws java.io.IOException {
      return newBuilder().mergeFrom(input).buildParsed();
    }
    public static ru.omnicomm.pegasus.messaging.settings.statedefinition.StateDefinitionSettingsParser.StateDefinitionMessageSettings parseFrom(
        com.google.protobuf.CodedInputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return newBuilder().mergeFrom(input, extensionRegistry)
               .buildParsed();
    }
    
    public static Builder newBuilder() { return Builder.create(); }
    public Builder newBuilderForType() { return newBuilder(); }
    public static Builder newBuilder(ru.omnicomm.pegasus.messaging.settings.statedefinition.StateDefinitionSettingsParser.StateDefinitionMessageSettings prototype) {
      return newBuilder().mergeFrom(prototype);
    }
    public Builder toBuilder() { return newBuilder(this); }
    
    @java.lang.Override
    protected Builder newBuilderForType(
        com.google.protobuf.GeneratedMessage.BuilderParent parent) {
      Builder builder = new Builder(parent);
      return builder;
    }
    public static final class Builder extends
        com.google.protobuf.GeneratedMessage.Builder<Builder>
       implements ru.omnicomm.pegasus.messaging.settings.statedefinition.StateDefinitionSettingsParser.StateDefinitionMessageSettingsOrBuilder {
      public static final com.google.protobuf.Descriptors.Descriptor
          getDescriptor() {
        return ru.omnicomm.pegasus.messaging.settings.statedefinition.StateDefinitionSettingsParser.internal_static_ru_omnicomm_pegasus_messaging_settings_statedefinition_StateDefinitionMessageSettings_descriptor;
      }
      
      protected com.google.protobuf.GeneratedMessage.FieldAccessorTable
          internalGetFieldAccessorTable() {
        return ru.omnicomm.pegasus.messaging.settings.statedefinition.StateDefinitionSettingsParser.internal_static_ru_omnicomm_pegasus_messaging_settings_statedefinition_StateDefinitionMessageSettings_fieldAccessorTable;
      }
      
      // Construct using ru.omnicomm.pegasus.messaging.settings.statedefinition.StateDefinitionSettingsParser.StateDefinitionMessageSettings.newBuilder()
      private Builder() {
        maybeForceBuilderInitialization();
      }
      
      private Builder(BuilderParent parent) {
        super(parent);
        maybeForceBuilderInitialization();
      }
      private void maybeForceBuilderInitialization() {
        if (com.google.protobuf.GeneratedMessage.alwaysUseFieldBuilders) {
        }
      }
      private static Builder create() {
        return new Builder();
      }
      
      public Builder clear() {
        super.clear();
        sourceId_ = 0L;
        bitField0_ = (bitField0_ & ~0x00000001);
        messageType_ = 526L;
        bitField0_ = (bitField0_ & ~0x00000002);
        timeStamp_ = 0L;
        bitField0_ = (bitField0_ & ~0x00000004);
        timeInterval_ = 0L;
        bitField0_ = (bitField0_ & ~0x00000008);
        time_ = 0L;
        bitField0_ = (bitField0_ & ~0x00000010);
        return this;
      }
      
      public Builder clone() {
        return create().mergeFrom(buildPartial());
      }
      
      public com.google.protobuf.Descriptors.Descriptor
          getDescriptorForType() {
        return ru.omnicomm.pegasus.messaging.settings.statedefinition.StateDefinitionSettingsParser.StateDefinitionMessageSettings.getDescriptor();
      }
      
      public ru.omnicomm.pegasus.messaging.settings.statedefinition.StateDefinitionSettingsParser.StateDefinitionMessageSettings getDefaultInstanceForType() {
        return ru.omnicomm.pegasus.messaging.settings.statedefinition.StateDefinitionSettingsParser.StateDefinitionMessageSettings.getDefaultInstance();
      }
      
      public ru.omnicomm.pegasus.messaging.settings.statedefinition.StateDefinitionSettingsParser.StateDefinitionMessageSettings build() {
        ru.omnicomm.pegasus.messaging.settings.statedefinition.StateDefinitionSettingsParser.StateDefinitionMessageSettings result = buildPartial();
        if (!result.isInitialized()) {
          throw newUninitializedMessageException(result);
        }
        return result;
      }
      
      private ru.omnicomm.pegasus.messaging.settings.statedefinition.StateDefinitionSettingsParser.StateDefinitionMessageSettings buildParsed()
          throws com.google.protobuf.InvalidProtocolBufferException {
        ru.omnicomm.pegasus.messaging.settings.statedefinition.StateDefinitionSettingsParser.StateDefinitionMessageSettings result = buildPartial();
        if (!result.isInitialized()) {
          throw newUninitializedMessageException(
            result).asInvalidProtocolBufferException();
        }
        return result;
      }
      
      public ru.omnicomm.pegasus.messaging.settings.statedefinition.StateDefinitionSettingsParser.StateDefinitionMessageSettings buildPartial() {
        ru.omnicomm.pegasus.messaging.settings.statedefinition.StateDefinitionSettingsParser.StateDefinitionMessageSettings result = new ru.omnicomm.pegasus.messaging.settings.statedefinition.StateDefinitionSettingsParser.StateDefinitionMessageSettings(this);
        int from_bitField0_ = bitField0_;
        int to_bitField0_ = 0;
        if (((from_bitField0_ & 0x00000001) == 0x00000001)) {
          to_bitField0_ |= 0x00000001;
        }
        result.sourceId_ = sourceId_;
        if (((from_bitField0_ & 0x00000002) == 0x00000002)) {
          to_bitField0_ |= 0x00000002;
        }
        result.messageType_ = messageType_;
        if (((from_bitField0_ & 0x00000004) == 0x00000004)) {
          to_bitField0_ |= 0x00000004;
        }
        result.timeStamp_ = timeStamp_;
        if (((from_bitField0_ & 0x00000008) == 0x00000008)) {
          to_bitField0_ |= 0x00000008;
        }
        result.timeInterval_ = timeInterval_;
        if (((from_bitField0_ & 0x00000010) == 0x00000010)) {
          to_bitField0_ |= 0x00000010;
        }
        result.time_ = time_;
        result.bitField0_ = to_bitField0_;
        onBuilt();
        return result;
      }
      
      public Builder mergeFrom(com.google.protobuf.Message other) {
        if (other instanceof ru.omnicomm.pegasus.messaging.settings.statedefinition.StateDefinitionSettingsParser.StateDefinitionMessageSettings) {
          return mergeFrom((ru.omnicomm.pegasus.messaging.settings.statedefinition.StateDefinitionSettingsParser.StateDefinitionMessageSettings)other);
        } else {
          super.mergeFrom(other);
          return this;
        }
      }
      
      public Builder mergeFrom(ru.omnicomm.pegasus.messaging.settings.statedefinition.StateDefinitionSettingsParser.StateDefinitionMessageSettings other) {
        if (other == ru.omnicomm.pegasus.messaging.settings.statedefinition.StateDefinitionSettingsParser.StateDefinitionMessageSettings.getDefaultInstance()) return this;
        if (other.hasSourceId()) {
          setSourceId(other.getSourceId());
        }
        if (other.hasMessageType()) {
          setMessageType(other.getMessageType());
        }
        if (other.hasTimeStamp()) {
          setTimeStamp(other.getTimeStamp());
        }
        if (other.hasTimeInterval()) {
          setTimeInterval(other.getTimeInterval());
        }
        if (other.hasTime()) {
          setTime(other.getTime());
        }
        this.mergeUnknownFields(other.getUnknownFields());
        return this;
      }
      
      public final boolean isInitialized() {
        if (!hasMessageType()) {
          
          return false;
        }
        return true;
      }
      
      public Builder mergeFrom(
          com.google.protobuf.CodedInputStream input,
          com.google.protobuf.ExtensionRegistryLite extensionRegistry)
          throws java.io.IOException {
        com.google.protobuf.UnknownFieldSet.Builder unknownFields =
          com.google.protobuf.UnknownFieldSet.newBuilder(
            this.getUnknownFields());
        while (true) {
          int tag = input.readTag();
          switch (tag) {
            case 0:
              this.setUnknownFields(unknownFields.build());
              onChanged();
              return this;
            default: {
              if (!parseUnknownField(input, unknownFields,
                                     extensionRegistry, tag)) {
                this.setUnknownFields(unknownFields.build());
                onChanged();
                return this;
              }
              break;
            }
            case 8: {
              bitField0_ |= 0x00000001;
              sourceId_ = input.readInt64();
              break;
            }
            case 16: {
              bitField0_ |= 0x00000002;
              messageType_ = input.readInt64();
              break;
            }
            case 40: {
              bitField0_ |= 0x00000004;
              timeStamp_ = input.readInt64();
              break;
            }
            case 808: {
              bitField0_ |= 0x00000008;
              timeInterval_ = input.readInt64();
              break;
            }
            case 816: {
              bitField0_ |= 0x00000010;
              time_ = input.readInt64();
              break;
            }
          }
        }
      }
      
      private int bitField0_;
      
      // optional int64 sourceId = 1;
      private long sourceId_ ;
      public boolean hasSourceId() {
        return ((bitField0_ & 0x00000001) == 0x00000001);
      }
      public long getSourceId() {
        return sourceId_;
      }
      public Builder setSourceId(long value) {
        bitField0_ |= 0x00000001;
        sourceId_ = value;
        onChanged();
        return this;
      }
      public Builder clearSourceId() {
        bitField0_ = (bitField0_ & ~0x00000001);
        sourceId_ = 0L;
        onChanged();
        return this;
      }
      
      // required int64 messageType = 2 [default = 526];
      private long messageType_ = 526L;
      public boolean hasMessageType() {
        return ((bitField0_ & 0x00000002) == 0x00000002);
      }
      public long getMessageType() {
        return messageType_;
      }
      public Builder setMessageType(long value) {
        bitField0_ |= 0x00000002;
        messageType_ = value;
        onChanged();
        return this;
      }
      public Builder clearMessageType() {
        bitField0_ = (bitField0_ & ~0x00000002);
        messageType_ = 526L;
        onChanged();
        return this;
      }
      
      // optional int64 timeStamp = 5;
      private long timeStamp_ ;
      public boolean hasTimeStamp() {
        return ((bitField0_ & 0x00000004) == 0x00000004);
      }
      public long getTimeStamp() {
        return timeStamp_;
      }
      public Builder setTimeStamp(long value) {
        bitField0_ |= 0x00000004;
        timeStamp_ = value;
        onChanged();
        return this;
      }
      public Builder clearTimeStamp() {
        bitField0_ = (bitField0_ & ~0x00000004);
        timeStamp_ = 0L;
        onChanged();
        return this;
      }
      
      // optional int64 timeInterval = 101;
      private long timeInterval_ ;
      public boolean hasTimeInterval() {
        return ((bitField0_ & 0x00000008) == 0x00000008);
      }
      public long getTimeInterval() {
        return timeInterval_;
      }
      public Builder setTimeInterval(long value) {
        bitField0_ |= 0x00000008;
        timeInterval_ = value;
        onChanged();
        return this;
      }
      public Builder clearTimeInterval() {
        bitField0_ = (bitField0_ & ~0x00000008);
        timeInterval_ = 0L;
        onChanged();
        return this;
      }
      
      // optional int64 time = 102;
      private long time_ ;
      public boolean hasTime() {
        return ((bitField0_ & 0x00000010) == 0x00000010);
      }
      public long getTime() {
        return time_;
      }
      public Builder setTime(long value) {
        bitField0_ |= 0x00000010;
        time_ = value;
        onChanged();
        return this;
      }
      public Builder clearTime() {
        bitField0_ = (bitField0_ & ~0x00000010);
        time_ = 0L;
        onChanged();
        return this;
      }
      
      // @@protoc_insertion_point(builder_scope:ru.omnicomm.pegasus.messaging.settings.statedefinition.StateDefinitionMessageSettings)
    }
    
    static {
      defaultInstance = new StateDefinitionMessageSettings(true);
      defaultInstance.initFields();
    }
    
    // @@protoc_insertion_point(class_scope:ru.omnicomm.pegasus.messaging.settings.statedefinition.StateDefinitionMessageSettings)
  }
  
  public interface StateDefinitionMessageBufferOrBuilder
      extends com.google.protobuf.MessageOrBuilder {
    
    // optional int64 sourceId = 1;
    boolean hasSourceId();
    long getSourceId();
    
    // required int64 messageType = 2 [default = 527];
    boolean hasMessageType();
    long getMessageType();
    
    // optional int64 timeStamp = 5;
    boolean hasTimeStamp();
    long getTimeStamp();
    
    // optional int64 timeInterval = 101;
    boolean hasTimeInterval();
    long getTimeInterval();
    
    // optional int64 time = 102;
    boolean hasTime();
    long getTime();
    
    // repeated .ru.omnicomm.pegasus.messaging.settings.statedefinition.StateDefinitionMessageBuffer.Data buffer = 105;
    java.util.List<ru.omnicomm.pegasus.messaging.settings.statedefinition.StateDefinitionSettingsParser.StateDefinitionMessageBuffer.Data> 
        getBufferList();
    ru.omnicomm.pegasus.messaging.settings.statedefinition.StateDefinitionSettingsParser.StateDefinitionMessageBuffer.Data getBuffer(int index);
    int getBufferCount();
    java.util.List<? extends ru.omnicomm.pegasus.messaging.settings.statedefinition.StateDefinitionSettingsParser.StateDefinitionMessageBuffer.DataOrBuilder> 
        getBufferOrBuilderList();
    ru.omnicomm.pegasus.messaging.settings.statedefinition.StateDefinitionSettingsParser.StateDefinitionMessageBuffer.DataOrBuilder getBufferOrBuilder(
        int index);
  }
  public static final class StateDefinitionMessageBuffer extends
      com.google.protobuf.GeneratedMessage
      implements StateDefinitionMessageBufferOrBuilder {
    // Use StateDefinitionMessageBuffer.newBuilder() to construct.
    private StateDefinitionMessageBuffer(Builder builder) {
      super(builder);
    }
    private StateDefinitionMessageBuffer(boolean noInit) {}
    
    private static final StateDefinitionMessageBuffer defaultInstance;
    public static StateDefinitionMessageBuffer getDefaultInstance() {
      return defaultInstance;
    }
    
    public StateDefinitionMessageBuffer getDefaultInstanceForType() {
      return defaultInstance;
    }
    
    public static final com.google.protobuf.Descriptors.Descriptor
        getDescriptor() {
      return ru.omnicomm.pegasus.messaging.settings.statedefinition.StateDefinitionSettingsParser.internal_static_ru_omnicomm_pegasus_messaging_settings_statedefinition_StateDefinitionMessageBuffer_descriptor;
    }
    
    protected com.google.protobuf.GeneratedMessage.FieldAccessorTable
        internalGetFieldAccessorTable() {
      return ru.omnicomm.pegasus.messaging.settings.statedefinition.StateDefinitionSettingsParser.internal_static_ru_omnicomm_pegasus_messaging_settings_statedefinition_StateDefinitionMessageBuffer_fieldAccessorTable;
    }
    
    public interface DataOrBuilder
        extends com.google.protobuf.MessageOrBuilder {
      
      // optional int64 timeStamp = 1;
      boolean hasTimeStamp();
      long getTimeStamp();
      
      // optional int64 messageType = 2;
      boolean hasMessageType();
      long getMessageType();
      
      // repeated int32 intValue = 4;
      java.util.List<java.lang.Integer> getIntValueList();
      int getIntValueCount();
      int getIntValue(int index);
      
      // repeated double doubleValue = 5;
      java.util.List<java.lang.Double> getDoubleValueList();
      int getDoubleValueCount();
      double getDoubleValue(int index);
      
      // repeated bool booleanValue = 7;
      java.util.List<java.lang.Boolean> getBooleanValueList();
      int getBooleanValueCount();
      boolean getBooleanValue(int index);
      
      // repeated int64 longValue = 8;
      java.util.List<java.lang.Long> getLongValueList();
      int getLongValueCount();
      long getLongValue(int index);
    }
    public static final class Data extends
        com.google.protobuf.GeneratedMessage
        implements DataOrBuilder {
      // Use Data.newBuilder() to construct.
      private Data(Builder builder) {
        super(builder);
      }
      private Data(boolean noInit) {}
      
      private static final Data defaultInstance;
      public static Data getDefaultInstance() {
        return defaultInstance;
      }
      
      public Data getDefaultInstanceForType() {
        return defaultInstance;
      }
      
      public static final com.google.protobuf.Descriptors.Descriptor
          getDescriptor() {
        return ru.omnicomm.pegasus.messaging.settings.statedefinition.StateDefinitionSettingsParser.internal_static_ru_omnicomm_pegasus_messaging_settings_statedefinition_StateDefinitionMessageBuffer_Data_descriptor;
      }
      
      protected com.google.protobuf.GeneratedMessage.FieldAccessorTable
          internalGetFieldAccessorTable() {
        return ru.omnicomm.pegasus.messaging.settings.statedefinition.StateDefinitionSettingsParser.internal_static_ru_omnicomm_pegasus_messaging_settings_statedefinition_StateDefinitionMessageBuffer_Data_fieldAccessorTable;
      }
      
      private int bitField0_;
      // optional int64 timeStamp = 1;
      public static final int TIMESTAMP_FIELD_NUMBER = 1;
      private long timeStamp_;
      public boolean hasTimeStamp() {
        return ((bitField0_ & 0x00000001) == 0x00000001);
      }
      public long getTimeStamp() {
        return timeStamp_;
      }
      
      // optional int64 messageType = 2;
      public static final int MESSAGETYPE_FIELD_NUMBER = 2;
      private long messageType_;
      public boolean hasMessageType() {
        return ((bitField0_ & 0x00000002) == 0x00000002);
      }
      public long getMessageType() {
        return messageType_;
      }
      
      // repeated int32 intValue = 4;
      public static final int INTVALUE_FIELD_NUMBER = 4;
      private java.util.List<java.lang.Integer> intValue_;
      public java.util.List<java.lang.Integer>
          getIntValueList() {
        return intValue_;
      }
      public int getIntValueCount() {
        return intValue_.size();
      }
      public int getIntValue(int index) {
        return intValue_.get(index);
      }
      
      // repeated double doubleValue = 5;
      public static final int DOUBLEVALUE_FIELD_NUMBER = 5;
      private java.util.List<java.lang.Double> doubleValue_;
      public java.util.List<java.lang.Double>
          getDoubleValueList() {
        return doubleValue_;
      }
      public int getDoubleValueCount() {
        return doubleValue_.size();
      }
      public double getDoubleValue(int index) {
        return doubleValue_.get(index);
      }
      
      // repeated bool booleanValue = 7;
      public static final int BOOLEANVALUE_FIELD_NUMBER = 7;
      private java.util.List<java.lang.Boolean> booleanValue_;
      public java.util.List<java.lang.Boolean>
          getBooleanValueList() {
        return booleanValue_;
      }
      public int getBooleanValueCount() {
        return booleanValue_.size();
      }
      public boolean getBooleanValue(int index) {
        return booleanValue_.get(index);
      }
      
      // repeated int64 longValue = 8;
      public static final int LONGVALUE_FIELD_NUMBER = 8;
      private java.util.List<java.lang.Long> longValue_;
      public java.util.List<java.lang.Long>
          getLongValueList() {
        return longValue_;
      }
      public int getLongValueCount() {
        return longValue_.size();
      }
      public long getLongValue(int index) {
        return longValue_.get(index);
      }
      
      private void initFields() {
        timeStamp_ = 0L;
        messageType_ = 0L;
        intValue_ = java.util.Collections.emptyList();;
        doubleValue_ = java.util.Collections.emptyList();;
        booleanValue_ = java.util.Collections.emptyList();;
        longValue_ = java.util.Collections.emptyList();;
      }
      private byte memoizedIsInitialized = -1;
      public final boolean isInitialized() {
        byte isInitialized = memoizedIsInitialized;
        if (isInitialized != -1) return isInitialized == 1;
        
        memoizedIsInitialized = 1;
        return true;
      }
      
      public void writeTo(com.google.protobuf.CodedOutputStream output)
                          throws java.io.IOException {
        getSerializedSize();
        if (((bitField0_ & 0x00000001) == 0x00000001)) {
          output.writeInt64(1, timeStamp_);
        }
        if (((bitField0_ & 0x00000002) == 0x00000002)) {
          output.writeInt64(2, messageType_);
        }
        for (int i = 0; i < intValue_.size(); i++) {
          output.writeInt32(4, intValue_.get(i));
        }
        for (int i = 0; i < doubleValue_.size(); i++) {
          output.writeDouble(5, doubleValue_.get(i));
        }
        for (int i = 0; i < booleanValue_.size(); i++) {
          output.writeBool(7, booleanValue_.get(i));
        }
        for (int i = 0; i < longValue_.size(); i++) {
          output.writeInt64(8, longValue_.get(i));
        }
        getUnknownFields().writeTo(output);
      }
      
      private int memoizedSerializedSize = -1;
      public int getSerializedSize() {
        int size = memoizedSerializedSize;
        if (size != -1) return size;
      
        size = 0;
        if (((bitField0_ & 0x00000001) == 0x00000001)) {
          size += com.google.protobuf.CodedOutputStream
            .computeInt64Size(1, timeStamp_);
        }
        if (((bitField0_ & 0x00000002) == 0x00000002)) {
          size += com.google.protobuf.CodedOutputStream
            .computeInt64Size(2, messageType_);
        }
        {
          int dataSize = 0;
          for (int i = 0; i < intValue_.size(); i++) {
            dataSize += com.google.protobuf.CodedOutputStream
              .computeInt32SizeNoTag(intValue_.get(i));
          }
          size += dataSize;
          size += 1 * getIntValueList().size();
        }
        {
          int dataSize = 0;
          dataSize = 8 * getDoubleValueList().size();
          size += dataSize;
          size += 1 * getDoubleValueList().size();
        }
        {
          int dataSize = 0;
          dataSize = 1 * getBooleanValueList().size();
          size += dataSize;
          size += 1 * getBooleanValueList().size();
        }
        {
          int dataSize = 0;
          for (int i = 0; i < longValue_.size(); i++) {
            dataSize += com.google.protobuf.CodedOutputStream
              .computeInt64SizeNoTag(longValue_.get(i));
          }
          size += dataSize;
          size += 1 * getLongValueList().size();
        }
        size += getUnknownFields().getSerializedSize();
        memoizedSerializedSize = size;
        return size;
      }
      
      private static final long serialVersionUID = 0L;
      @java.lang.Override
      protected java.lang.Object writeReplace()
          throws java.io.ObjectStreamException {
        return super.writeReplace();
      }
      
      public static ru.omnicomm.pegasus.messaging.settings.statedefinition.StateDefinitionSettingsParser.StateDefinitionMessageBuffer.Data parseFrom(
          com.google.protobuf.ByteString data)
          throws com.google.protobuf.InvalidProtocolBufferException {
        return newBuilder().mergeFrom(data).buildParsed();
      }
      public static ru.omnicomm.pegasus.messaging.settings.statedefinition.StateDefinitionSettingsParser.StateDefinitionMessageBuffer.Data parseFrom(
          com.google.protobuf.ByteString data,
          com.google.protobuf.ExtensionRegistryLite extensionRegistry)
          throws com.google.protobuf.InvalidProtocolBufferException {
        return newBuilder().mergeFrom(data, extensionRegistry)
                 .buildParsed();
      }
      public static ru.omnicomm.pegasus.messaging.settings.statedefinition.StateDefinitionSettingsParser.StateDefinitionMessageBuffer.Data parseFrom(byte[] data)
          throws com.google.protobuf.InvalidProtocolBufferException {
        return newBuilder().mergeFrom(data).buildParsed();
      }
      public static ru.omnicomm.pegasus.messaging.settings.statedefinition.StateDefinitionSettingsParser.StateDefinitionMessageBuffer.Data parseFrom(
          byte[] data,
          com.google.protobuf.ExtensionRegistryLite extensionRegistry)
          throws com.google.protobuf.InvalidProtocolBufferException {
        return newBuilder().mergeFrom(data, extensionRegistry)
                 .buildParsed();
      }
      public static ru.omnicomm.pegasus.messaging.settings.statedefinition.StateDefinitionSettingsParser.StateDefinitionMessageBuffer.Data parseFrom(java.io.InputStream input)
          throws java.io.IOException {
        return newBuilder().mergeFrom(input).buildParsed();
      }
      public static ru.omnicomm.pegasus.messaging.settings.statedefinition.StateDefinitionSettingsParser.StateDefinitionMessageBuffer.Data parseFrom(
          java.io.InputStream input,
          com.google.protobuf.ExtensionRegistryLite extensionRegistry)
          throws java.io.IOException {
        return newBuilder().mergeFrom(input, extensionRegistry)
                 .buildParsed();
      }
      public static ru.omnicomm.pegasus.messaging.settings.statedefinition.StateDefinitionSettingsParser.StateDefinitionMessageBuffer.Data parseDelimitedFrom(java.io.InputStream input)
          throws java.io.IOException {
        Builder builder = newBuilder();
        if (builder.mergeDelimitedFrom(input)) {
          return builder.buildParsed();
        } else {
          return null;
        }
      }
      public static ru.omnicomm.pegasus.messaging.settings.statedefinition.StateDefinitionSettingsParser.StateDefinitionMessageBuffer.Data parseDelimitedFrom(
          java.io.InputStream input,
          com.google.protobuf.ExtensionRegistryLite extensionRegistry)
          throws java.io.IOException {
        Builder builder = newBuilder();
        if (builder.mergeDelimitedFrom(input, extensionRegistry)) {
          return builder.buildParsed();
        } else {
          return null;
        }
      }
      public static ru.omnicomm.pegasus.messaging.settings.statedefinition.StateDefinitionSettingsParser.StateDefinitionMessageBuffer.Data parseFrom(
          com.google.protobuf.CodedInputStream input)
          throws java.io.IOException {
        return newBuilder().mergeFrom(input).buildParsed();
      }
      public static ru.omnicomm.pegasus.messaging.settings.statedefinition.StateDefinitionSettingsParser.StateDefinitionMessageBuffer.Data parseFrom(
          com.google.protobuf.CodedInputStream input,
          com.google.protobuf.ExtensionRegistryLite extensionRegistry)
          throws java.io.IOException {
        return newBuilder().mergeFrom(input, extensionRegistry)
                 .buildParsed();
      }
      
      public static Builder newBuilder() { return Builder.create(); }
      public Builder newBuilderForType() { return newBuilder(); }
      public static Builder newBuilder(ru.omnicomm.pegasus.messaging.settings.statedefinition.StateDefinitionSettingsParser.StateDefinitionMessageBuffer.Data prototype) {
        return newBuilder().mergeFrom(prototype);
      }
      public Builder toBuilder() { return newBuilder(this); }
      
      @java.lang.Override
      protected Builder newBuilderForType(
          com.google.protobuf.GeneratedMessage.BuilderParent parent) {
        Builder builder = new Builder(parent);
        return builder;
      }
      public static final class Builder extends
          com.google.protobuf.GeneratedMessage.Builder<Builder>
         implements ru.omnicomm.pegasus.messaging.settings.statedefinition.StateDefinitionSettingsParser.StateDefinitionMessageBuffer.DataOrBuilder {
        public static final com.google.protobuf.Descriptors.Descriptor
            getDescriptor() {
          return ru.omnicomm.pegasus.messaging.settings.statedefinition.StateDefinitionSettingsParser.internal_static_ru_omnicomm_pegasus_messaging_settings_statedefinition_StateDefinitionMessageBuffer_Data_descriptor;
        }
        
        protected com.google.protobuf.GeneratedMessage.FieldAccessorTable
            internalGetFieldAccessorTable() {
          return ru.omnicomm.pegasus.messaging.settings.statedefinition.StateDefinitionSettingsParser.internal_static_ru_omnicomm_pegasus_messaging_settings_statedefinition_StateDefinitionMessageBuffer_Data_fieldAccessorTable;
        }
        
        // Construct using ru.omnicomm.pegasus.messaging.settings.statedefinition.StateDefinitionSettingsParser.StateDefinitionMessageBuffer.Data.newBuilder()
        private Builder() {
          maybeForceBuilderInitialization();
        }
        
        private Builder(BuilderParent parent) {
          super(parent);
          maybeForceBuilderInitialization();
        }
        private void maybeForceBuilderInitialization() {
          if (com.google.protobuf.GeneratedMessage.alwaysUseFieldBuilders) {
          }
        }
        private static Builder create() {
          return new Builder();
        }
        
        public Builder clear() {
          super.clear();
          timeStamp_ = 0L;
          bitField0_ = (bitField0_ & ~0x00000001);
          messageType_ = 0L;
          bitField0_ = (bitField0_ & ~0x00000002);
          intValue_ = java.util.Collections.emptyList();;
          bitField0_ = (bitField0_ & ~0x00000004);
          doubleValue_ = java.util.Collections.emptyList();;
          bitField0_ = (bitField0_ & ~0x00000008);
          booleanValue_ = java.util.Collections.emptyList();;
          bitField0_ = (bitField0_ & ~0x00000010);
          longValue_ = java.util.Collections.emptyList();;
          bitField0_ = (bitField0_ & ~0x00000020);
          return this;
        }
        
        public Builder clone() {
          return create().mergeFrom(buildPartial());
        }
        
        public com.google.protobuf.Descriptors.Descriptor
            getDescriptorForType() {
          return ru.omnicomm.pegasus.messaging.settings.statedefinition.StateDefinitionSettingsParser.StateDefinitionMessageBuffer.Data.getDescriptor();
        }
        
        public ru.omnicomm.pegasus.messaging.settings.statedefinition.StateDefinitionSettingsParser.StateDefinitionMessageBuffer.Data getDefaultInstanceForType() {
          return ru.omnicomm.pegasus.messaging.settings.statedefinition.StateDefinitionSettingsParser.StateDefinitionMessageBuffer.Data.getDefaultInstance();
        }
        
        public ru.omnicomm.pegasus.messaging.settings.statedefinition.StateDefinitionSettingsParser.StateDefinitionMessageBuffer.Data build() {
          ru.omnicomm.pegasus.messaging.settings.statedefinition.StateDefinitionSettingsParser.StateDefinitionMessageBuffer.Data result = buildPartial();
          if (!result.isInitialized()) {
            throw newUninitializedMessageException(result);
          }
          return result;
        }
        
        private ru.omnicomm.pegasus.messaging.settings.statedefinition.StateDefinitionSettingsParser.StateDefinitionMessageBuffer.Data buildParsed()
            throws com.google.protobuf.InvalidProtocolBufferException {
          ru.omnicomm.pegasus.messaging.settings.statedefinition.StateDefinitionSettingsParser.StateDefinitionMessageBuffer.Data result = buildPartial();
          if (!result.isInitialized()) {
            throw newUninitializedMessageException(
              result).asInvalidProtocolBufferException();
          }
          return result;
        }
        
        public ru.omnicomm.pegasus.messaging.settings.statedefinition.StateDefinitionSettingsParser.StateDefinitionMessageBuffer.Data buildPartial() {
          ru.omnicomm.pegasus.messaging.settings.statedefinition.StateDefinitionSettingsParser.StateDefinitionMessageBuffer.Data result = new ru.omnicomm.pegasus.messaging.settings.statedefinition.StateDefinitionSettingsParser.StateDefinitionMessageBuffer.Data(this);
          int from_bitField0_ = bitField0_;
          int to_bitField0_ = 0;
          if (((from_bitField0_ & 0x00000001) == 0x00000001)) {
            to_bitField0_ |= 0x00000001;
          }
          result.timeStamp_ = timeStamp_;
          if (((from_bitField0_ & 0x00000002) == 0x00000002)) {
            to_bitField0_ |= 0x00000002;
          }
          result.messageType_ = messageType_;
          if (((bitField0_ & 0x00000004) == 0x00000004)) {
            intValue_ = java.util.Collections.unmodifiableList(intValue_);
            bitField0_ = (bitField0_ & ~0x00000004);
          }
          result.intValue_ = intValue_;
          if (((bitField0_ & 0x00000008) == 0x00000008)) {
            doubleValue_ = java.util.Collections.unmodifiableList(doubleValue_);
            bitField0_ = (bitField0_ & ~0x00000008);
          }
          result.doubleValue_ = doubleValue_;
          if (((bitField0_ & 0x00000010) == 0x00000010)) {
            booleanValue_ = java.util.Collections.unmodifiableList(booleanValue_);
            bitField0_ = (bitField0_ & ~0x00000010);
          }
          result.booleanValue_ = booleanValue_;
          if (((bitField0_ & 0x00000020) == 0x00000020)) {
            longValue_ = java.util.Collections.unmodifiableList(longValue_);
            bitField0_ = (bitField0_ & ~0x00000020);
          }
          result.longValue_ = longValue_;
          result.bitField0_ = to_bitField0_;
          onBuilt();
          return result;
        }
        
        public Builder mergeFrom(com.google.protobuf.Message other) {
          if (other instanceof ru.omnicomm.pegasus.messaging.settings.statedefinition.StateDefinitionSettingsParser.StateDefinitionMessageBuffer.Data) {
            return mergeFrom((ru.omnicomm.pegasus.messaging.settings.statedefinition.StateDefinitionSettingsParser.StateDefinitionMessageBuffer.Data)other);
          } else {
            super.mergeFrom(other);
            return this;
          }
        }
        
        public Builder mergeFrom(ru.omnicomm.pegasus.messaging.settings.statedefinition.StateDefinitionSettingsParser.StateDefinitionMessageBuffer.Data other) {
          if (other == ru.omnicomm.pegasus.messaging.settings.statedefinition.StateDefinitionSettingsParser.StateDefinitionMessageBuffer.Data.getDefaultInstance()) return this;
          if (other.hasTimeStamp()) {
            setTimeStamp(other.getTimeStamp());
          }
          if (other.hasMessageType()) {
            setMessageType(other.getMessageType());
          }
          if (!other.intValue_.isEmpty()) {
            if (intValue_.isEmpty()) {
              intValue_ = other.intValue_;
              bitField0_ = (bitField0_ & ~0x00000004);
            } else {
              ensureIntValueIsMutable();
              intValue_.addAll(other.intValue_);
            }
            onChanged();
          }
          if (!other.doubleValue_.isEmpty()) {
            if (doubleValue_.isEmpty()) {
              doubleValue_ = other.doubleValue_;
              bitField0_ = (bitField0_ & ~0x00000008);
            } else {
              ensureDoubleValueIsMutable();
              doubleValue_.addAll(other.doubleValue_);
            }
            onChanged();
          }
          if (!other.booleanValue_.isEmpty()) {
            if (booleanValue_.isEmpty()) {
              booleanValue_ = other.booleanValue_;
              bitField0_ = (bitField0_ & ~0x00000010);
            } else {
              ensureBooleanValueIsMutable();
              booleanValue_.addAll(other.booleanValue_);
            }
            onChanged();
          }
          if (!other.longValue_.isEmpty()) {
            if (longValue_.isEmpty()) {
              longValue_ = other.longValue_;
              bitField0_ = (bitField0_ & ~0x00000020);
            } else {
              ensureLongValueIsMutable();
              longValue_.addAll(other.longValue_);
            }
            onChanged();
          }
          this.mergeUnknownFields(other.getUnknownFields());
          return this;
        }
        
        public final boolean isInitialized() {
          return true;
        }
        
        public Builder mergeFrom(
            com.google.protobuf.CodedInputStream input,
            com.google.protobuf.ExtensionRegistryLite extensionRegistry)
            throws java.io.IOException {
          com.google.protobuf.UnknownFieldSet.Builder unknownFields =
            com.google.protobuf.UnknownFieldSet.newBuilder(
              this.getUnknownFields());
          while (true) {
            int tag = input.readTag();
            switch (tag) {
              case 0:
                this.setUnknownFields(unknownFields.build());
                onChanged();
                return this;
              default: {
                if (!parseUnknownField(input, unknownFields,
                                       extensionRegistry, tag)) {
                  this.setUnknownFields(unknownFields.build());
                  onChanged();
                  return this;
                }
                break;
              }
              case 8: {
                bitField0_ |= 0x00000001;
                timeStamp_ = input.readInt64();
                break;
              }
              case 16: {
                bitField0_ |= 0x00000002;
                messageType_ = input.readInt64();
                break;
              }
              case 32: {
                ensureIntValueIsMutable();
                intValue_.add(input.readInt32());
                break;
              }
              case 34: {
                int length = input.readRawVarint32();
                int limit = input.pushLimit(length);
                while (input.getBytesUntilLimit() > 0) {
                  addIntValue(input.readInt32());
                }
                input.popLimit(limit);
                break;
              }
              case 41: {
                ensureDoubleValueIsMutable();
                doubleValue_.add(input.readDouble());
                break;
              }
              case 42: {
                int length = input.readRawVarint32();
                int limit = input.pushLimit(length);
                while (input.getBytesUntilLimit() > 0) {
                  addDoubleValue(input.readDouble());
                }
                input.popLimit(limit);
                break;
              }
              case 56: {
                ensureBooleanValueIsMutable();
                booleanValue_.add(input.readBool());
                break;
              }
              case 58: {
                int length = input.readRawVarint32();
                int limit = input.pushLimit(length);
                while (input.getBytesUntilLimit() > 0) {
                  addBooleanValue(input.readBool());
                }
                input.popLimit(limit);
                break;
              }
              case 64: {
                ensureLongValueIsMutable();
                longValue_.add(input.readInt64());
                break;
              }
              case 66: {
                int length = input.readRawVarint32();
                int limit = input.pushLimit(length);
                while (input.getBytesUntilLimit() > 0) {
                  addLongValue(input.readInt64());
                }
                input.popLimit(limit);
                break;
              }
            }
          }
        }
        
        private int bitField0_;
        
        // optional int64 timeStamp = 1;
        private long timeStamp_ ;
        public boolean hasTimeStamp() {
          return ((bitField0_ & 0x00000001) == 0x00000001);
        }
        public long getTimeStamp() {
          return timeStamp_;
        }
        public Builder setTimeStamp(long value) {
          bitField0_ |= 0x00000001;
          timeStamp_ = value;
          onChanged();
          return this;
        }
        public Builder clearTimeStamp() {
          bitField0_ = (bitField0_ & ~0x00000001);
          timeStamp_ = 0L;
          onChanged();
          return this;
        }
        
        // optional int64 messageType = 2;
        private long messageType_ ;
        public boolean hasMessageType() {
          return ((bitField0_ & 0x00000002) == 0x00000002);
        }
        public long getMessageType() {
          return messageType_;
        }
        public Builder setMessageType(long value) {
          bitField0_ |= 0x00000002;
          messageType_ = value;
          onChanged();
          return this;
        }
        public Builder clearMessageType() {
          bitField0_ = (bitField0_ & ~0x00000002);
          messageType_ = 0L;
          onChanged();
          return this;
        }
        
        // repeated int32 intValue = 4;
        private java.util.List<java.lang.Integer> intValue_ = java.util.Collections.emptyList();;
        private void ensureIntValueIsMutable() {
          if (!((bitField0_ & 0x00000004) == 0x00000004)) {
            intValue_ = new java.util.ArrayList<java.lang.Integer>(intValue_);
            bitField0_ |= 0x00000004;
           }
        }
        public java.util.List<java.lang.Integer>
            getIntValueList() {
          return java.util.Collections.unmodifiableList(intValue_);
        }
        public int getIntValueCount() {
          return intValue_.size();
        }
        public int getIntValue(int index) {
          return intValue_.get(index);
        }
        public Builder setIntValue(
            int index, int value) {
          ensureIntValueIsMutable();
          intValue_.set(index, value);
          onChanged();
          return this;
        }
        public Builder addIntValue(int value) {
          ensureIntValueIsMutable();
          intValue_.add(value);
          onChanged();
          return this;
        }
        public Builder addAllIntValue(
            java.lang.Iterable<? extends java.lang.Integer> values) {
          ensureIntValueIsMutable();
          super.addAll(values, intValue_);
          onChanged();
          return this;
        }
        public Builder clearIntValue() {
          intValue_ = java.util.Collections.emptyList();;
          bitField0_ = (bitField0_ & ~0x00000004);
          onChanged();
          return this;
        }
        
        // repeated double doubleValue = 5;
        private java.util.List<java.lang.Double> doubleValue_ = java.util.Collections.emptyList();;
        private void ensureDoubleValueIsMutable() {
          if (!((bitField0_ & 0x00000008) == 0x00000008)) {
            doubleValue_ = new java.util.ArrayList<java.lang.Double>(doubleValue_);
            bitField0_ |= 0x00000008;
           }
        }
        public java.util.List<java.lang.Double>
            getDoubleValueList() {
          return java.util.Collections.unmodifiableList(doubleValue_);
        }
        public int getDoubleValueCount() {
          return doubleValue_.size();
        }
        public double getDoubleValue(int index) {
          return doubleValue_.get(index);
        }
        public Builder setDoubleValue(
            int index, double value) {
          ensureDoubleValueIsMutable();
          doubleValue_.set(index, value);
          onChanged();
          return this;
        }
        public Builder addDoubleValue(double value) {
          ensureDoubleValueIsMutable();
          doubleValue_.add(value);
          onChanged();
          return this;
        }
        public Builder addAllDoubleValue(
            java.lang.Iterable<? extends java.lang.Double> values) {
          ensureDoubleValueIsMutable();
          super.addAll(values, doubleValue_);
          onChanged();
          return this;
        }
        public Builder clearDoubleValue() {
          doubleValue_ = java.util.Collections.emptyList();;
          bitField0_ = (bitField0_ & ~0x00000008);
          onChanged();
          return this;
        }
        
        // repeated bool booleanValue = 7;
        private java.util.List<java.lang.Boolean> booleanValue_ = java.util.Collections.emptyList();;
        private void ensureBooleanValueIsMutable() {
          if (!((bitField0_ & 0x00000010) == 0x00000010)) {
            booleanValue_ = new java.util.ArrayList<java.lang.Boolean>(booleanValue_);
            bitField0_ |= 0x00000010;
           }
        }
        public java.util.List<java.lang.Boolean>
            getBooleanValueList() {
          return java.util.Collections.unmodifiableList(booleanValue_);
        }
        public int getBooleanValueCount() {
          return booleanValue_.size();
        }
        public boolean getBooleanValue(int index) {
          return booleanValue_.get(index);
        }
        public Builder setBooleanValue(
            int index, boolean value) {
          ensureBooleanValueIsMutable();
          booleanValue_.set(index, value);
          onChanged();
          return this;
        }
        public Builder addBooleanValue(boolean value) {
          ensureBooleanValueIsMutable();
          booleanValue_.add(value);
          onChanged();
          return this;
        }
        public Builder addAllBooleanValue(
            java.lang.Iterable<? extends java.lang.Boolean> values) {
          ensureBooleanValueIsMutable();
          super.addAll(values, booleanValue_);
          onChanged();
          return this;
        }
        public Builder clearBooleanValue() {
          booleanValue_ = java.util.Collections.emptyList();;
          bitField0_ = (bitField0_ & ~0x00000010);
          onChanged();
          return this;
        }
        
        // repeated int64 longValue = 8;
        private java.util.List<java.lang.Long> longValue_ = java.util.Collections.emptyList();;
        private void ensureLongValueIsMutable() {
          if (!((bitField0_ & 0x00000020) == 0x00000020)) {
            longValue_ = new java.util.ArrayList<java.lang.Long>(longValue_);
            bitField0_ |= 0x00000020;
           }
        }
        public java.util.List<java.lang.Long>
            getLongValueList() {
          return java.util.Collections.unmodifiableList(longValue_);
        }
        public int getLongValueCount() {
          return longValue_.size();
        }
        public long getLongValue(int index) {
          return longValue_.get(index);
        }
        public Builder setLongValue(
            int index, long value) {
          ensureLongValueIsMutable();
          longValue_.set(index, value);
          onChanged();
          return this;
        }
        public Builder addLongValue(long value) {
          ensureLongValueIsMutable();
          longValue_.add(value);
          onChanged();
          return this;
        }
        public Builder addAllLongValue(
            java.lang.Iterable<? extends java.lang.Long> values) {
          ensureLongValueIsMutable();
          super.addAll(values, longValue_);
          onChanged();
          return this;
        }
        public Builder clearLongValue() {
          longValue_ = java.util.Collections.emptyList();;
          bitField0_ = (bitField0_ & ~0x00000020);
          onChanged();
          return this;
        }
        
        // @@protoc_insertion_point(builder_scope:ru.omnicomm.pegasus.messaging.settings.statedefinition.StateDefinitionMessageBuffer.Data)
      }
      
      static {
        defaultInstance = new Data(true);
        defaultInstance.initFields();
      }
      
      // @@protoc_insertion_point(class_scope:ru.omnicomm.pegasus.messaging.settings.statedefinition.StateDefinitionMessageBuffer.Data)
    }
    
    private int bitField0_;
    // optional int64 sourceId = 1;
    public static final int SOURCEID_FIELD_NUMBER = 1;
    private long sourceId_;
    public boolean hasSourceId() {
      return ((bitField0_ & 0x00000001) == 0x00000001);
    }
    public long getSourceId() {
      return sourceId_;
    }
    
    // required int64 messageType = 2 [default = 527];
    public static final int MESSAGETYPE_FIELD_NUMBER = 2;
    private long messageType_;
    public boolean hasMessageType() {
      return ((bitField0_ & 0x00000002) == 0x00000002);
    }
    public long getMessageType() {
      return messageType_;
    }
    
    // optional int64 timeStamp = 5;
    public static final int TIMESTAMP_FIELD_NUMBER = 5;
    private long timeStamp_;
    public boolean hasTimeStamp() {
      return ((bitField0_ & 0x00000004) == 0x00000004);
    }
    public long getTimeStamp() {
      return timeStamp_;
    }
    
    // optional int64 timeInterval = 101;
    public static final int TIMEINTERVAL_FIELD_NUMBER = 101;
    private long timeInterval_;
    public boolean hasTimeInterval() {
      return ((bitField0_ & 0x00000008) == 0x00000008);
    }
    public long getTimeInterval() {
      return timeInterval_;
    }
    
    // optional int64 time = 102;
    public static final int TIME_FIELD_NUMBER = 102;
    private long time_;
    public boolean hasTime() {
      return ((bitField0_ & 0x00000010) == 0x00000010);
    }
    public long getTime() {
      return time_;
    }
    
    // repeated .ru.omnicomm.pegasus.messaging.settings.statedefinition.StateDefinitionMessageBuffer.Data buffer = 105;
    public static final int BUFFER_FIELD_NUMBER = 105;
    private java.util.List<ru.omnicomm.pegasus.messaging.settings.statedefinition.StateDefinitionSettingsParser.StateDefinitionMessageBuffer.Data> buffer_;
    public java.util.List<ru.omnicomm.pegasus.messaging.settings.statedefinition.StateDefinitionSettingsParser.StateDefinitionMessageBuffer.Data> getBufferList() {
      return buffer_;
    }
    public java.util.List<? extends ru.omnicomm.pegasus.messaging.settings.statedefinition.StateDefinitionSettingsParser.StateDefinitionMessageBuffer.DataOrBuilder> 
        getBufferOrBuilderList() {
      return buffer_;
    }
    public int getBufferCount() {
      return buffer_.size();
    }
    public ru.omnicomm.pegasus.messaging.settings.statedefinition.StateDefinitionSettingsParser.StateDefinitionMessageBuffer.Data getBuffer(int index) {
      return buffer_.get(index);
    }
    public ru.omnicomm.pegasus.messaging.settings.statedefinition.StateDefinitionSettingsParser.StateDefinitionMessageBuffer.DataOrBuilder getBufferOrBuilder(
        int index) {
      return buffer_.get(index);
    }
    
    private void initFields() {
      sourceId_ = 0L;
      messageType_ = 527L;
      timeStamp_ = 0L;
      timeInterval_ = 0L;
      time_ = 0L;
      buffer_ = java.util.Collections.emptyList();
    }
    private byte memoizedIsInitialized = -1;
    public final boolean isInitialized() {
      byte isInitialized = memoizedIsInitialized;
      if (isInitialized != -1) return isInitialized == 1;
      
      if (!hasMessageType()) {
        memoizedIsInitialized = 0;
        return false;
      }
      memoizedIsInitialized = 1;
      return true;
    }
    
    public void writeTo(com.google.protobuf.CodedOutputStream output)
                        throws java.io.IOException {
      getSerializedSize();
      if (((bitField0_ & 0x00000001) == 0x00000001)) {
        output.writeInt64(1, sourceId_);
      }
      if (((bitField0_ & 0x00000002) == 0x00000002)) {
        output.writeInt64(2, messageType_);
      }
      if (((bitField0_ & 0x00000004) == 0x00000004)) {
        output.writeInt64(5, timeStamp_);
      }
      if (((bitField0_ & 0x00000008) == 0x00000008)) {
        output.writeInt64(101, timeInterval_);
      }
      if (((bitField0_ & 0x00000010) == 0x00000010)) {
        output.writeInt64(102, time_);
      }
      for (int i = 0; i < buffer_.size(); i++) {
        output.writeMessage(105, buffer_.get(i));
      }
      getUnknownFields().writeTo(output);
    }
    
    private int memoizedSerializedSize = -1;
    public int getSerializedSize() {
      int size = memoizedSerializedSize;
      if (size != -1) return size;
    
      size = 0;
      if (((bitField0_ & 0x00000001) == 0x00000001)) {
        size += com.google.protobuf.CodedOutputStream
          .computeInt64Size(1, sourceId_);
      }
      if (((bitField0_ & 0x00000002) == 0x00000002)) {
        size += com.google.protobuf.CodedOutputStream
          .computeInt64Size(2, messageType_);
      }
      if (((bitField0_ & 0x00000004) == 0x00000004)) {
        size += com.google.protobuf.CodedOutputStream
          .computeInt64Size(5, timeStamp_);
      }
      if (((bitField0_ & 0x00000008) == 0x00000008)) {
        size += com.google.protobuf.CodedOutputStream
          .computeInt64Size(101, timeInterval_);
      }
      if (((bitField0_ & 0x00000010) == 0x00000010)) {
        size += com.google.protobuf.CodedOutputStream
          .computeInt64Size(102, time_);
      }
      for (int i = 0; i < buffer_.size(); i++) {
        size += com.google.protobuf.CodedOutputStream
          .computeMessageSize(105, buffer_.get(i));
      }
      size += getUnknownFields().getSerializedSize();
      memoizedSerializedSize = size;
      return size;
    }
    
    private static final long serialVersionUID = 0L;
    @java.lang.Override
    protected java.lang.Object writeReplace()
        throws java.io.ObjectStreamException {
      return super.writeReplace();
    }
    
    public static ru.omnicomm.pegasus.messaging.settings.statedefinition.StateDefinitionSettingsParser.StateDefinitionMessageBuffer parseFrom(
        com.google.protobuf.ByteString data)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return newBuilder().mergeFrom(data).buildParsed();
    }
    public static ru.omnicomm.pegasus.messaging.settings.statedefinition.StateDefinitionSettingsParser.StateDefinitionMessageBuffer parseFrom(
        com.google.protobuf.ByteString data,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return newBuilder().mergeFrom(data, extensionRegistry)
               .buildParsed();
    }
    public static ru.omnicomm.pegasus.messaging.settings.statedefinition.StateDefinitionSettingsParser.StateDefinitionMessageBuffer parseFrom(byte[] data)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return newBuilder().mergeFrom(data).buildParsed();
    }
    public static ru.omnicomm.pegasus.messaging.settings.statedefinition.StateDefinitionSettingsParser.StateDefinitionMessageBuffer parseFrom(
        byte[] data,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      return newBuilder().mergeFrom(data, extensionRegistry)
               .buildParsed();
    }
    public static ru.omnicomm.pegasus.messaging.settings.statedefinition.StateDefinitionSettingsParser.StateDefinitionMessageBuffer parseFrom(java.io.InputStream input)
        throws java.io.IOException {
      return newBuilder().mergeFrom(input).buildParsed();
    }
    public static ru.omnicomm.pegasus.messaging.settings.statedefinition.StateDefinitionSettingsParser.StateDefinitionMessageBuffer parseFrom(
        java.io.InputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return newBuilder().mergeFrom(input, extensionRegistry)
               .buildParsed();
    }
    public static ru.omnicomm.pegasus.messaging.settings.statedefinition.StateDefinitionSettingsParser.StateDefinitionMessageBuffer parseDelimitedFrom(java.io.InputStream input)
        throws java.io.IOException {
      Builder builder = newBuilder();
      if (builder.mergeDelimitedFrom(input)) {
        return builder.buildParsed();
      } else {
        return null;
      }
    }
    public static ru.omnicomm.pegasus.messaging.settings.statedefinition.StateDefinitionSettingsParser.StateDefinitionMessageBuffer parseDelimitedFrom(
        java.io.InputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      Builder builder = newBuilder();
      if (builder.mergeDelimitedFrom(input, extensionRegistry)) {
        return builder.buildParsed();
      } else {
        return null;
      }
    }
    public static ru.omnicomm.pegasus.messaging.settings.statedefinition.StateDefinitionSettingsParser.StateDefinitionMessageBuffer parseFrom(
        com.google.protobuf.CodedInputStream input)
        throws java.io.IOException {
      return newBuilder().mergeFrom(input).buildParsed();
    }
    public static ru.omnicomm.pegasus.messaging.settings.statedefinition.StateDefinitionSettingsParser.StateDefinitionMessageBuffer parseFrom(
        com.google.protobuf.CodedInputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      return newBuilder().mergeFrom(input, extensionRegistry)
               .buildParsed();
    }
    
    public static Builder newBuilder() { return Builder.create(); }
    public Builder newBuilderForType() { return newBuilder(); }
    public static Builder newBuilder(ru.omnicomm.pegasus.messaging.settings.statedefinition.StateDefinitionSettingsParser.StateDefinitionMessageBuffer prototype) {
      return newBuilder().mergeFrom(prototype);
    }
    public Builder toBuilder() { return newBuilder(this); }
    
    @java.lang.Override
    protected Builder newBuilderForType(
        com.google.protobuf.GeneratedMessage.BuilderParent parent) {
      Builder builder = new Builder(parent);
      return builder;
    }
    public static final class Builder extends
        com.google.protobuf.GeneratedMessage.Builder<Builder>
       implements ru.omnicomm.pegasus.messaging.settings.statedefinition.StateDefinitionSettingsParser.StateDefinitionMessageBufferOrBuilder {
      public static final com.google.protobuf.Descriptors.Descriptor
          getDescriptor() {
        return ru.omnicomm.pegasus.messaging.settings.statedefinition.StateDefinitionSettingsParser.internal_static_ru_omnicomm_pegasus_messaging_settings_statedefinition_StateDefinitionMessageBuffer_descriptor;
      }
      
      protected com.google.protobuf.GeneratedMessage.FieldAccessorTable
          internalGetFieldAccessorTable() {
        return ru.omnicomm.pegasus.messaging.settings.statedefinition.StateDefinitionSettingsParser.internal_static_ru_omnicomm_pegasus_messaging_settings_statedefinition_StateDefinitionMessageBuffer_fieldAccessorTable;
      }
      
      // Construct using ru.omnicomm.pegasus.messaging.settings.statedefinition.StateDefinitionSettingsParser.StateDefinitionMessageBuffer.newBuilder()
      private Builder() {
        maybeForceBuilderInitialization();
      }
      
      private Builder(BuilderParent parent) {
        super(parent);
        maybeForceBuilderInitialization();
      }
      private void maybeForceBuilderInitialization() {
        if (com.google.protobuf.GeneratedMessage.alwaysUseFieldBuilders) {
          getBufferFieldBuilder();
        }
      }
      private static Builder create() {
        return new Builder();
      }
      
      public Builder clear() {
        super.clear();
        sourceId_ = 0L;
        bitField0_ = (bitField0_ & ~0x00000001);
        messageType_ = 527L;
        bitField0_ = (bitField0_ & ~0x00000002);
        timeStamp_ = 0L;
        bitField0_ = (bitField0_ & ~0x00000004);
        timeInterval_ = 0L;
        bitField0_ = (bitField0_ & ~0x00000008);
        time_ = 0L;
        bitField0_ = (bitField0_ & ~0x00000010);
        if (bufferBuilder_ == null) {
          buffer_ = java.util.Collections.emptyList();
          bitField0_ = (bitField0_ & ~0x00000020);
        } else {
          bufferBuilder_.clear();
        }
        return this;
      }
      
      public Builder clone() {
        return create().mergeFrom(buildPartial());
      }
      
      public com.google.protobuf.Descriptors.Descriptor
          getDescriptorForType() {
        return ru.omnicomm.pegasus.messaging.settings.statedefinition.StateDefinitionSettingsParser.StateDefinitionMessageBuffer.getDescriptor();
      }
      
      public ru.omnicomm.pegasus.messaging.settings.statedefinition.StateDefinitionSettingsParser.StateDefinitionMessageBuffer getDefaultInstanceForType() {
        return ru.omnicomm.pegasus.messaging.settings.statedefinition.StateDefinitionSettingsParser.StateDefinitionMessageBuffer.getDefaultInstance();
      }
      
      public ru.omnicomm.pegasus.messaging.settings.statedefinition.StateDefinitionSettingsParser.StateDefinitionMessageBuffer build() {
        ru.omnicomm.pegasus.messaging.settings.statedefinition.StateDefinitionSettingsParser.StateDefinitionMessageBuffer result = buildPartial();
        if (!result.isInitialized()) {
          throw newUninitializedMessageException(result);
        }
        return result;
      }
      
      private ru.omnicomm.pegasus.messaging.settings.statedefinition.StateDefinitionSettingsParser.StateDefinitionMessageBuffer buildParsed()
          throws com.google.protobuf.InvalidProtocolBufferException {
        ru.omnicomm.pegasus.messaging.settings.statedefinition.StateDefinitionSettingsParser.StateDefinitionMessageBuffer result = buildPartial();
        if (!result.isInitialized()) {
          throw newUninitializedMessageException(
            result).asInvalidProtocolBufferException();
        }
        return result;
      }
      
      public ru.omnicomm.pegasus.messaging.settings.statedefinition.StateDefinitionSettingsParser.StateDefinitionMessageBuffer buildPartial() {
        ru.omnicomm.pegasus.messaging.settings.statedefinition.StateDefinitionSettingsParser.StateDefinitionMessageBuffer result = new ru.omnicomm.pegasus.messaging.settings.statedefinition.StateDefinitionSettingsParser.StateDefinitionMessageBuffer(this);
        int from_bitField0_ = bitField0_;
        int to_bitField0_ = 0;
        if (((from_bitField0_ & 0x00000001) == 0x00000001)) {
          to_bitField0_ |= 0x00000001;
        }
        result.sourceId_ = sourceId_;
        if (((from_bitField0_ & 0x00000002) == 0x00000002)) {
          to_bitField0_ |= 0x00000002;
        }
        result.messageType_ = messageType_;
        if (((from_bitField0_ & 0x00000004) == 0x00000004)) {
          to_bitField0_ |= 0x00000004;
        }
        result.timeStamp_ = timeStamp_;
        if (((from_bitField0_ & 0x00000008) == 0x00000008)) {
          to_bitField0_ |= 0x00000008;
        }
        result.timeInterval_ = timeInterval_;
        if (((from_bitField0_ & 0x00000010) == 0x00000010)) {
          to_bitField0_ |= 0x00000010;
        }
        result.time_ = time_;
        if (bufferBuilder_ == null) {
          if (((bitField0_ & 0x00000020) == 0x00000020)) {
            buffer_ = java.util.Collections.unmodifiableList(buffer_);
            bitField0_ = (bitField0_ & ~0x00000020);
          }
          result.buffer_ = buffer_;
        } else {
          result.buffer_ = bufferBuilder_.build();
        }
        result.bitField0_ = to_bitField0_;
        onBuilt();
        return result;
      }
      
      public Builder mergeFrom(com.google.protobuf.Message other) {
        if (other instanceof ru.omnicomm.pegasus.messaging.settings.statedefinition.StateDefinitionSettingsParser.StateDefinitionMessageBuffer) {
          return mergeFrom((ru.omnicomm.pegasus.messaging.settings.statedefinition.StateDefinitionSettingsParser.StateDefinitionMessageBuffer)other);
        } else {
          super.mergeFrom(other);
          return this;
        }
      }
      
      public Builder mergeFrom(ru.omnicomm.pegasus.messaging.settings.statedefinition.StateDefinitionSettingsParser.StateDefinitionMessageBuffer other) {
        if (other == ru.omnicomm.pegasus.messaging.settings.statedefinition.StateDefinitionSettingsParser.StateDefinitionMessageBuffer.getDefaultInstance()) return this;
        if (other.hasSourceId()) {
          setSourceId(other.getSourceId());
        }
        if (other.hasMessageType()) {
          setMessageType(other.getMessageType());
        }
        if (other.hasTimeStamp()) {
          setTimeStamp(other.getTimeStamp());
        }
        if (other.hasTimeInterval()) {
          setTimeInterval(other.getTimeInterval());
        }
        if (other.hasTime()) {
          setTime(other.getTime());
        }
        if (bufferBuilder_ == null) {
          if (!other.buffer_.isEmpty()) {
            if (buffer_.isEmpty()) {
              buffer_ = other.buffer_;
              bitField0_ = (bitField0_ & ~0x00000020);
            } else {
              ensureBufferIsMutable();
              buffer_.addAll(other.buffer_);
            }
            onChanged();
          }
        } else {
          if (!other.buffer_.isEmpty()) {
            if (bufferBuilder_.isEmpty()) {
              bufferBuilder_.dispose();
              bufferBuilder_ = null;
              buffer_ = other.buffer_;
              bitField0_ = (bitField0_ & ~0x00000020);
              bufferBuilder_ = 
                com.google.protobuf.GeneratedMessage.alwaysUseFieldBuilders ?
                   getBufferFieldBuilder() : null;
            } else {
              bufferBuilder_.addAllMessages(other.buffer_);
            }
          }
        }
        this.mergeUnknownFields(other.getUnknownFields());
        return this;
      }
      
      public final boolean isInitialized() {
        if (!hasMessageType()) {
          
          return false;
        }
        return true;
      }
      
      public Builder mergeFrom(
          com.google.protobuf.CodedInputStream input,
          com.google.protobuf.ExtensionRegistryLite extensionRegistry)
          throws java.io.IOException {
        com.google.protobuf.UnknownFieldSet.Builder unknownFields =
          com.google.protobuf.UnknownFieldSet.newBuilder(
            this.getUnknownFields());
        while (true) {
          int tag = input.readTag();
          switch (tag) {
            case 0:
              this.setUnknownFields(unknownFields.build());
              onChanged();
              return this;
            default: {
              if (!parseUnknownField(input, unknownFields,
                                     extensionRegistry, tag)) {
                this.setUnknownFields(unknownFields.build());
                onChanged();
                return this;
              }
              break;
            }
            case 8: {
              bitField0_ |= 0x00000001;
              sourceId_ = input.readInt64();
              break;
            }
            case 16: {
              bitField0_ |= 0x00000002;
              messageType_ = input.readInt64();
              break;
            }
            case 40: {
              bitField0_ |= 0x00000004;
              timeStamp_ = input.readInt64();
              break;
            }
            case 808: {
              bitField0_ |= 0x00000008;
              timeInterval_ = input.readInt64();
              break;
            }
            case 816: {
              bitField0_ |= 0x00000010;
              time_ = input.readInt64();
              break;
            }
            case 842: {
              ru.omnicomm.pegasus.messaging.settings.statedefinition.StateDefinitionSettingsParser.StateDefinitionMessageBuffer.Data.Builder subBuilder = ru.omnicomm.pegasus.messaging.settings.statedefinition.StateDefinitionSettingsParser.StateDefinitionMessageBuffer.Data.newBuilder();
              input.readMessage(subBuilder, extensionRegistry);
              addBuffer(subBuilder.buildPartial());
              break;
            }
          }
        }
      }
      
      private int bitField0_;
      
      // optional int64 sourceId = 1;
      private long sourceId_ ;
      public boolean hasSourceId() {
        return ((bitField0_ & 0x00000001) == 0x00000001);
      }
      public long getSourceId() {
        return sourceId_;
      }
      public Builder setSourceId(long value) {
        bitField0_ |= 0x00000001;
        sourceId_ = value;
        onChanged();
        return this;
      }
      public Builder clearSourceId() {
        bitField0_ = (bitField0_ & ~0x00000001);
        sourceId_ = 0L;
        onChanged();
        return this;
      }
      
      // required int64 messageType = 2 [default = 527];
      private long messageType_ = 527L;
      public boolean hasMessageType() {
        return ((bitField0_ & 0x00000002) == 0x00000002);
      }
      public long getMessageType() {
        return messageType_;
      }
      public Builder setMessageType(long value) {
        bitField0_ |= 0x00000002;
        messageType_ = value;
        onChanged();
        return this;
      }
      public Builder clearMessageType() {
        bitField0_ = (bitField0_ & ~0x00000002);
        messageType_ = 527L;
        onChanged();
        return this;
      }
      
      // optional int64 timeStamp = 5;
      private long timeStamp_ ;
      public boolean hasTimeStamp() {
        return ((bitField0_ & 0x00000004) == 0x00000004);
      }
      public long getTimeStamp() {
        return timeStamp_;
      }
      public Builder setTimeStamp(long value) {
        bitField0_ |= 0x00000004;
        timeStamp_ = value;
        onChanged();
        return this;
      }
      public Builder clearTimeStamp() {
        bitField0_ = (bitField0_ & ~0x00000004);
        timeStamp_ = 0L;
        onChanged();
        return this;
      }
      
      // optional int64 timeInterval = 101;
      private long timeInterval_ ;
      public boolean hasTimeInterval() {
        return ((bitField0_ & 0x00000008) == 0x00000008);
      }
      public long getTimeInterval() {
        return timeInterval_;
      }
      public Builder setTimeInterval(long value) {
        bitField0_ |= 0x00000008;
        timeInterval_ = value;
        onChanged();
        return this;
      }
      public Builder clearTimeInterval() {
        bitField0_ = (bitField0_ & ~0x00000008);
        timeInterval_ = 0L;
        onChanged();
        return this;
      }
      
      // optional int64 time = 102;
      private long time_ ;
      public boolean hasTime() {
        return ((bitField0_ & 0x00000010) == 0x00000010);
      }
      public long getTime() {
        return time_;
      }
      public Builder setTime(long value) {
        bitField0_ |= 0x00000010;
        time_ = value;
        onChanged();
        return this;
      }
      public Builder clearTime() {
        bitField0_ = (bitField0_ & ~0x00000010);
        time_ = 0L;
        onChanged();
        return this;
      }
      
      // repeated .ru.omnicomm.pegasus.messaging.settings.statedefinition.StateDefinitionMessageBuffer.Data buffer = 105;
      private java.util.List<ru.omnicomm.pegasus.messaging.settings.statedefinition.StateDefinitionSettingsParser.StateDefinitionMessageBuffer.Data> buffer_ =
        java.util.Collections.emptyList();
      private void ensureBufferIsMutable() {
        if (!((bitField0_ & 0x00000020) == 0x00000020)) {
          buffer_ = new java.util.ArrayList<ru.omnicomm.pegasus.messaging.settings.statedefinition.StateDefinitionSettingsParser.StateDefinitionMessageBuffer.Data>(buffer_);
          bitField0_ |= 0x00000020;
         }
      }
      
      private com.google.protobuf.RepeatedFieldBuilder<
          ru.omnicomm.pegasus.messaging.settings.statedefinition.StateDefinitionSettingsParser.StateDefinitionMessageBuffer.Data, ru.omnicomm.pegasus.messaging.settings.statedefinition.StateDefinitionSettingsParser.StateDefinitionMessageBuffer.Data.Builder, ru.omnicomm.pegasus.messaging.settings.statedefinition.StateDefinitionSettingsParser.StateDefinitionMessageBuffer.DataOrBuilder> bufferBuilder_;
      
      public java.util.List<ru.omnicomm.pegasus.messaging.settings.statedefinition.StateDefinitionSettingsParser.StateDefinitionMessageBuffer.Data> getBufferList() {
        if (bufferBuilder_ == null) {
          return java.util.Collections.unmodifiableList(buffer_);
        } else {
          return bufferBuilder_.getMessageList();
        }
      }
      public int getBufferCount() {
        if (bufferBuilder_ == null) {
          return buffer_.size();
        } else {
          return bufferBuilder_.getCount();
        }
      }
      public ru.omnicomm.pegasus.messaging.settings.statedefinition.StateDefinitionSettingsParser.StateDefinitionMessageBuffer.Data getBuffer(int index) {
        if (bufferBuilder_ == null) {
          return buffer_.get(index);
        } else {
          return bufferBuilder_.getMessage(index);
        }
      }
      public Builder setBuffer(
          int index, ru.omnicomm.pegasus.messaging.settings.statedefinition.StateDefinitionSettingsParser.StateDefinitionMessageBuffer.Data value) {
        if (bufferBuilder_ == null) {
          if (value == null) {
            throw new NullPointerException();
          }
          ensureBufferIsMutable();
          buffer_.set(index, value);
          onChanged();
        } else {
          bufferBuilder_.setMessage(index, value);
        }
        return this;
      }
      public Builder setBuffer(
          int index, ru.omnicomm.pegasus.messaging.settings.statedefinition.StateDefinitionSettingsParser.StateDefinitionMessageBuffer.Data.Builder builderForValue) {
        if (bufferBuilder_ == null) {
          ensureBufferIsMutable();
          buffer_.set(index, builderForValue.build());
          onChanged();
        } else {
          bufferBuilder_.setMessage(index, builderForValue.build());
        }
        return this;
      }
      public Builder addBuffer(ru.omnicomm.pegasus.messaging.settings.statedefinition.StateDefinitionSettingsParser.StateDefinitionMessageBuffer.Data value) {
        if (bufferBuilder_ == null) {
          if (value == null) {
            throw new NullPointerException();
          }
          ensureBufferIsMutable();
          buffer_.add(value);
          onChanged();
        } else {
          bufferBuilder_.addMessage(value);
        }
        return this;
      }
      public Builder addBuffer(
          int index, ru.omnicomm.pegasus.messaging.settings.statedefinition.StateDefinitionSettingsParser.StateDefinitionMessageBuffer.Data value) {
        if (bufferBuilder_ == null) {
          if (value == null) {
            throw new NullPointerException();
          }
          ensureBufferIsMutable();
          buffer_.add(index, value);
          onChanged();
        } else {
          bufferBuilder_.addMessage(index, value);
        }
        return this;
      }
      public Builder addBuffer(
          ru.omnicomm.pegasus.messaging.settings.statedefinition.StateDefinitionSettingsParser.StateDefinitionMessageBuffer.Data.Builder builderForValue) {
        if (bufferBuilder_ == null) {
          ensureBufferIsMutable();
          buffer_.add(builderForValue.build());
          onChanged();
        } else {
          bufferBuilder_.addMessage(builderForValue.build());
        }
        return this;
      }
      public Builder addBuffer(
          int index, ru.omnicomm.pegasus.messaging.settings.statedefinition.StateDefinitionSettingsParser.StateDefinitionMessageBuffer.Data.Builder builderForValue) {
        if (bufferBuilder_ == null) {
          ensureBufferIsMutable();
          buffer_.add(index, builderForValue.build());
          onChanged();
        } else {
          bufferBuilder_.addMessage(index, builderForValue.build());
        }
        return this;
      }
      public Builder addAllBuffer(
          java.lang.Iterable<? extends ru.omnicomm.pegasus.messaging.settings.statedefinition.StateDefinitionSettingsParser.StateDefinitionMessageBuffer.Data> values) {
        if (bufferBuilder_ == null) {
          ensureBufferIsMutable();
          super.addAll(values, buffer_);
          onChanged();
        } else {
          bufferBuilder_.addAllMessages(values);
        }
        return this;
      }
      public Builder clearBuffer() {
        if (bufferBuilder_ == null) {
          buffer_ = java.util.Collections.emptyList();
          bitField0_ = (bitField0_ & ~0x00000020);
          onChanged();
        } else {
          bufferBuilder_.clear();
        }
        return this;
      }
      public Builder removeBuffer(int index) {
        if (bufferBuilder_ == null) {
          ensureBufferIsMutable();
          buffer_.remove(index);
          onChanged();
        } else {
          bufferBuilder_.remove(index);
        }
        return this;
      }
      public ru.omnicomm.pegasus.messaging.settings.statedefinition.StateDefinitionSettingsParser.StateDefinitionMessageBuffer.Data.Builder getBufferBuilder(
          int index) {
        return getBufferFieldBuilder().getBuilder(index);
      }
      public ru.omnicomm.pegasus.messaging.settings.statedefinition.StateDefinitionSettingsParser.StateDefinitionMessageBuffer.DataOrBuilder getBufferOrBuilder(
          int index) {
        if (bufferBuilder_ == null) {
          return buffer_.get(index);  } else {
          return bufferBuilder_.getMessageOrBuilder(index);
        }
      }
      public java.util.List<? extends ru.omnicomm.pegasus.messaging.settings.statedefinition.StateDefinitionSettingsParser.StateDefinitionMessageBuffer.DataOrBuilder> 
           getBufferOrBuilderList() {
        if (bufferBuilder_ != null) {
          return bufferBuilder_.getMessageOrBuilderList();
        } else {
          return java.util.Collections.unmodifiableList(buffer_);
        }
      }
      public ru.omnicomm.pegasus.messaging.settings.statedefinition.StateDefinitionSettingsParser.StateDefinitionMessageBuffer.Data.Builder addBufferBuilder() {
        return getBufferFieldBuilder().addBuilder(
            ru.omnicomm.pegasus.messaging.settings.statedefinition.StateDefinitionSettingsParser.StateDefinitionMessageBuffer.Data.getDefaultInstance());
      }
      public ru.omnicomm.pegasus.messaging.settings.statedefinition.StateDefinitionSettingsParser.StateDefinitionMessageBuffer.Data.Builder addBufferBuilder(
          int index) {
        return getBufferFieldBuilder().addBuilder(
            index, ru.omnicomm.pegasus.messaging.settings.statedefinition.StateDefinitionSettingsParser.StateDefinitionMessageBuffer.Data.getDefaultInstance());
      }
      public java.util.List<ru.omnicomm.pegasus.messaging.settings.statedefinition.StateDefinitionSettingsParser.StateDefinitionMessageBuffer.Data.Builder> 
           getBufferBuilderList() {
        return getBufferFieldBuilder().getBuilderList();
      }
      private com.google.protobuf.RepeatedFieldBuilder<
          ru.omnicomm.pegasus.messaging.settings.statedefinition.StateDefinitionSettingsParser.StateDefinitionMessageBuffer.Data, ru.omnicomm.pegasus.messaging.settings.statedefinition.StateDefinitionSettingsParser.StateDefinitionMessageBuffer.Data.Builder, ru.omnicomm.pegasus.messaging.settings.statedefinition.StateDefinitionSettingsParser.StateDefinitionMessageBuffer.DataOrBuilder> 
          getBufferFieldBuilder() {
        if (bufferBuilder_ == null) {
          bufferBuilder_ = new com.google.protobuf.RepeatedFieldBuilder<
              ru.omnicomm.pegasus.messaging.settings.statedefinition.StateDefinitionSettingsParser.StateDefinitionMessageBuffer.Data, ru.omnicomm.pegasus.messaging.settings.statedefinition.StateDefinitionSettingsParser.StateDefinitionMessageBuffer.Data.Builder, ru.omnicomm.pegasus.messaging.settings.statedefinition.StateDefinitionSettingsParser.StateDefinitionMessageBuffer.DataOrBuilder>(
                  buffer_,
                  ((bitField0_ & 0x00000020) == 0x00000020),
                  getParentForChildren(),
                  isClean());
          buffer_ = null;
        }
        return bufferBuilder_;
      }
      
      // @@protoc_insertion_point(builder_scope:ru.omnicomm.pegasus.messaging.settings.statedefinition.StateDefinitionMessageBuffer)
    }
    
    static {
      defaultInstance = new StateDefinitionMessageBuffer(true);
      defaultInstance.initFields();
    }
    
    // @@protoc_insertion_point(class_scope:ru.omnicomm.pegasus.messaging.settings.statedefinition.StateDefinitionMessageBuffer)
  }
  
  private static com.google.protobuf.Descriptors.Descriptor
    internal_static_ru_omnicomm_pegasus_messaging_settings_statedefinition_StateDefinitionMessageSettings_descriptor;
  private static
    com.google.protobuf.GeneratedMessage.FieldAccessorTable
      internal_static_ru_omnicomm_pegasus_messaging_settings_statedefinition_StateDefinitionMessageSettings_fieldAccessorTable;
  private static com.google.protobuf.Descriptors.Descriptor
    internal_static_ru_omnicomm_pegasus_messaging_settings_statedefinition_StateDefinitionMessageBuffer_descriptor;
  private static
    com.google.protobuf.GeneratedMessage.FieldAccessorTable
      internal_static_ru_omnicomm_pegasus_messaging_settings_statedefinition_StateDefinitionMessageBuffer_fieldAccessorTable;
  private static com.google.protobuf.Descriptors.Descriptor
    internal_static_ru_omnicomm_pegasus_messaging_settings_statedefinition_StateDefinitionMessageBuffer_Data_descriptor;
  private static
    com.google.protobuf.GeneratedMessage.FieldAccessorTable
      internal_static_ru_omnicomm_pegasus_messaging_settings_statedefinition_StateDefinitionMessageBuffer_Data_fieldAccessorTable;
  
  public static com.google.protobuf.Descriptors.FileDescriptor
      getDescriptor() {
    return descriptor;
  }
  private static com.google.protobuf.Descriptors.FileDescriptor
      descriptor;
  static {
    java.lang.String[] descriptorData = {
      "\n\025StateDefinition.proto\0226ru.omnicomm.peg" +
      "asus.messaging.settings.statedefinition\"" +
      "\203\001\n\036StateDefinitionMessageSettings\022\020\n\010so" +
      "urceId\030\001 \001(\003\022\030\n\013messageType\030\002 \002(\003:\003526\022\021" +
      "\n\ttimeStamp\030\005 \001(\003\022\024\n\014timeInterval\030e \001(\003\022" +
      "\014\n\004time\030f \001(\003\"\354\002\n\034StateDefinitionMessage" +
      "Buffer\022\020\n\010sourceId\030\001 \001(\003\022\030\n\013messageType\030" +
      "\002 \002(\003:\003527\022\021\n\ttimeStamp\030\005 \001(\003\022\024\n\014timeInt" +
      "erval\030e \001(\003\022\014\n\004time\030f \001(\003\022i\n\006buffer\030i \003(" +
      "\0132Y.ru.omnicomm.pegasus.messaging.settin",
      "gs.statedefinition.StateDefinitionMessag" +
      "eBuffer.Data\032~\n\004Data\022\021\n\ttimeStamp\030\001 \001(\003\022" +
      "\023\n\013messageType\030\002 \001(\003\022\020\n\010intValue\030\004 \003(\005\022\023" +
      "\n\013doubleValue\030\005 \003(\001\022\024\n\014booleanValue\030\007 \003(" +
      "\010\022\021\n\tlongValue\030\010 \003(\003BW\n6ru.omnicomm.pega" +
      "sus.messaging.settings.statedefinitionB\035" +
      "StateDefinitionSettingsParser"
    };
    com.google.protobuf.Descriptors.FileDescriptor.InternalDescriptorAssigner assigner =
      new com.google.protobuf.Descriptors.FileDescriptor.InternalDescriptorAssigner() {
        public com.google.protobuf.ExtensionRegistry assignDescriptors(
            com.google.protobuf.Descriptors.FileDescriptor root) {
          descriptor = root;
          internal_static_ru_omnicomm_pegasus_messaging_settings_statedefinition_StateDefinitionMessageSettings_descriptor =
            getDescriptor().getMessageTypes().get(0);
          internal_static_ru_omnicomm_pegasus_messaging_settings_statedefinition_StateDefinitionMessageSettings_fieldAccessorTable = new
            com.google.protobuf.GeneratedMessage.FieldAccessorTable(
              internal_static_ru_omnicomm_pegasus_messaging_settings_statedefinition_StateDefinitionMessageSettings_descriptor,
              new java.lang.String[] { "SourceId", "MessageType", "TimeStamp", "TimeInterval", "Time", },
              ru.omnicomm.pegasus.messaging.settings.statedefinition.StateDefinitionSettingsParser.StateDefinitionMessageSettings.class,
              ru.omnicomm.pegasus.messaging.settings.statedefinition.StateDefinitionSettingsParser.StateDefinitionMessageSettings.Builder.class);
          internal_static_ru_omnicomm_pegasus_messaging_settings_statedefinition_StateDefinitionMessageBuffer_descriptor =
            getDescriptor().getMessageTypes().get(1);
          internal_static_ru_omnicomm_pegasus_messaging_settings_statedefinition_StateDefinitionMessageBuffer_fieldAccessorTable = new
            com.google.protobuf.GeneratedMessage.FieldAccessorTable(
              internal_static_ru_omnicomm_pegasus_messaging_settings_statedefinition_StateDefinitionMessageBuffer_descriptor,
              new java.lang.String[] { "SourceId", "MessageType", "TimeStamp", "TimeInterval", "Time", "Buffer", },
              ru.omnicomm.pegasus.messaging.settings.statedefinition.StateDefinitionSettingsParser.StateDefinitionMessageBuffer.class,
              ru.omnicomm.pegasus.messaging.settings.statedefinition.StateDefinitionSettingsParser.StateDefinitionMessageBuffer.Builder.class);
          internal_static_ru_omnicomm_pegasus_messaging_settings_statedefinition_StateDefinitionMessageBuffer_Data_descriptor =
            internal_static_ru_omnicomm_pegasus_messaging_settings_statedefinition_StateDefinitionMessageBuffer_descriptor.getNestedTypes().get(0);
          internal_static_ru_omnicomm_pegasus_messaging_settings_statedefinition_StateDefinitionMessageBuffer_Data_fieldAccessorTable = new
            com.google.protobuf.GeneratedMessage.FieldAccessorTable(
              internal_static_ru_omnicomm_pegasus_messaging_settings_statedefinition_StateDefinitionMessageBuffer_Data_descriptor,
              new java.lang.String[] { "TimeStamp", "MessageType", "IntValue", "DoubleValue", "BooleanValue", "LongValue", },
              ru.omnicomm.pegasus.messaging.settings.statedefinition.StateDefinitionSettingsParser.StateDefinitionMessageBuffer.Data.class,
              ru.omnicomm.pegasus.messaging.settings.statedefinition.StateDefinitionSettingsParser.StateDefinitionMessageBuffer.Data.Builder.class);
          return null;
        }
      };
    com.google.protobuf.Descriptors.FileDescriptor
      .internalBuildGeneratedFileFrom(descriptorData,
        new com.google.protobuf.Descriptors.FileDescriptor[] {
        }, assigner);
  }
  
  // @@protoc_insertion_point(outer_class_scope)
}
